require "import"
import "android.speech.SpeechRecognizer"
import "android.speech.RecognitionListener"
import "android.speech.RecognizerIntent"
import "java.util.Locale"
import "android.content.Intent"
import "android.net.Uri"
import "com.androlua.*"
import "cjson"

local narutoAktif = false

function shinobiKapital(teks)
    return teks:gsub("(%S+)", function(kata)
        return kata:gsub("%a", string.upper, 1)
    end)
end

function encodeShinobi(teks)
    if teks then
        teks = string.gsub(teks, "\n", "\r\n")
        teks = string.gsub(teks, "([^%w %-%_%.%~])",
            function(c) return string.format("%%%02X", string.byte(c)) end)
        teks = string.gsub(teks, " ", "+")
    end
    return teks
end

function matiinNaruto()
    if naruto then
        naruto.destroy()
        naruto = nil
        narutoAktif = false
    end
    return true
end

function mulaiShinobi()
    if narutoAktif then
        service.speak("Mesin pengenalan suara sedang sibuk, coba lagi nanti yah.")
        return
    end

    narutoAktif = true
    naruto = SpeechRecognizer.createSpeechRecognizer(service)
    kurama = RecognitionListener{
        onResults = function(hasil)
            dataUchiha = hasil.getParcelableArrayList(SpeechRecognizer.RESULTS_RECOGNITION)
            if dataUchiha and dataUchiha.size() > 0 then
                local teksSasuke = shinobiKapital(dataUchiha.get(0))
                local instruksiShuriken = "(Logika: Kamu adalah ai yang akan merevisi tulisan. Tugas kamu adalah memberi simbol yang benar ke dalam setiap tulisan, Tanda baca harus teratur jangan kebanyakan tanda titik ya, Untuk mengoperasikan tulisan yang sesuai. Terus kamu juga harus menyisipkan tanda baca yang beraturan kalau belum ada tanda bacanya ya, Jangan tulisannya seperti yang profesional ataupun seperti orang tua dan membosankan. Tapi jangan kebanyakan emojinya sesuaikan aja, Di setiap tulisan kamu juga harus sisipkan emoji di akhir ataupun sesuaikanlah di setiap kalimat ataupun disesuaikan untuk penambahan emojinya biar rapih, Jadikan emoji sebuah ekspresi.  Setelah kamu mengerjakannya dan sukses ataupun selesai jangan memberitahukan mereka bahwa kamu telah mengubahnya, Jangan kamu memberikan komentar instruksi logika perintah dan lain sebagainya, Jadi kirim aja hasilnya yang telah direvisi tidak perlu komentar. Berikut tulisan yang harus kamu revisi::::):\n\n"
                local teksNaruto = instruksiShuriken .. teksSasuke
                kirimKeNano(teksNaruto)
                matiinNaruto()
            end
        end,
        onError = function(kode)
            local pesanHokage = "Hi: "
            if kode == SpeechRecognizer.ERROR_NETWORK_TIMEOUT then
                pesanHokage = pesanHokage .. "Koneksi internet tidak tersedia. Silakan sambungkan ke Wi-Fi atau data seluler yah."
            elseif kode == SpeechRecognizer.ERROR_SPEECH_TIMEOUT then
                pesanHokage = pesanHokage .. "Waktu pengenalan mesin habis dan ucapan dirimu tidak terdeteksi, coba lagi yah. Support: Nazar Muhammad Indonesia."
            elseif kode == SpeechRecognizer.ERROR_CLIENT or kode == SpeechRecognizer.ERROR_INSUFFICIENT_PERMISSIONS then
                pesanHokage = pesanHokage .. "Ada masalah dengan layanan pengenalan suara. Mohon coba lagi nanti dan cek izin microphone."
            elseif kode == SpeechRecognizer.ERROR_NO_MATCH then
                pesanHokage = pesanHokage .. "Tidak ada yang terdeteksi ucapanmu, coba lagi yah."
            elseif kode == SpeechRecognizer.ERROR_RECOGNIZER_BUSY then
                pesanHokage = pesanHokage .. "Mesin pengenalan suara sedang sibuk, coba lagi nanti yah."
            elseif kode == SpeechRecognizer.ERROR_SERVER then
                pesanHokage = pesanHokage .. "Ada masalah dengan server, mohon coba lagi nanti."
            else
                pesanHokage = pesanHokage .. "Ucapan dirimu tidak terdeteksi, silakan coba lagi yah. Support: Nazar Muhammad Indonesia."
            end
            service.speak(pesanHokage)
            matiinNaruto()
        end
    }
    intentRasengan = Intent(RecognizerIntent.ACTION_RECOGNIZE_SPEECH)
    intentRasengan.putExtra(RecognizerIntent.EXTRA_LANGUAGE_MODEL, RecognizerIntent.LANGUAGE_MODEL_FREE_FORM)
    intentRasengan.putExtra(RecognizerIntent.EXTRA_LANGUAGE, Locale.getDefault())
    intentRasengan.putExtra(RecognizerIntent.EXTRA_CALLING_PACKAGE, service.getPackageName())
    naruto.setRecognitionListener(kurama)
    naruto.startListening(intentRasengan)
end

function kirimKeNano(teks)
    local teksEncoded = encodeShinobi(teks)
    local url = "https://ai.glitchy.workers.dev/ai/" .. teksEncoded

    Http.get(url, function(status, data)
        responNano(status, data)
    end)
end

function responNano(status, data)
    if status == 200 then
        local responsJutsu = cjson.decode(data)
        if responsJutsu and responsJutsu.msg then
            local teksFinal = responsJutsu.msg
            service.paste(teksFinal)
            service.speak(teksFinal)
        else
            service.speak("Error: Ada masalah yang tidak diketahui silakan hubungi bang nazar.")
        end
    end
end

mulaiShinobi()